<?php
namespace Claromentis\Core\Like\Controller;

$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"] ?: array()) + array("use" . "r_i" . "d" => base64_decode("dXNlcl9" . "pZA=="), "_5784e706ef84e048186" . "a70a164fcc358" => base64_decode("T2JqZWN0IElEIGlzIG5vdCBzcGVjaWZpZWQgb3IgaW52YWxpZA" . "=="), "_f4eafa5f493306f" . "fdb51a688b21dd50" . "7" => base64_decode("dG" . "90" . "YW" . "w="), "_37317e99" . "fd1ac0bd2" . "cca360fcc" . "5fd612" => base64_decode("dXNlcl9uYW1lLmJ" . "vZHk="), "_532af466941018fd39" . "54ccc8aed6a235" => base64_decode("bGlr" . "ZWQ="), "_71f564ea75084c6f26" . "1db81c655d2f73" => base64_decode("cHJvZm" . "lsZV9s" . "aW5rLm" . "hyZWY="), "_5e8488c" . "301cda00" . "85b5ca6c" . "78c50687" . "d" => base64_decode("cHJvZmlsZ" . "V9waG90by" . "5zcmM="), "_62d701c3c53404f06345eb" . "35720a47b4" => base64_decode("aXNfbn" . "VtZXJp" . "Yw=="), "_5203b6250b088a619a" . "f741a56f3a0c26" => base64_decode("Y29tbW9uL2xpa2UvbGlrZXJz" . "X2xpc3QuaHRtbA=="), "_2409bed918465b496e1f712f2c6514" . "03" => base64_decode("bGlrZXJzLm" . "RhdGFzcmM="), "_4d707fab" . "93bebb00b" . "be69e8159" . "697c90" => base64_decode(""), "_aa45d9aa411eac890" . "badddfedf2ade38" => base64_decode("T2JqZWN0IHR5cGUgaXMgbm90IHNwZWNpZmllZA=" . "="));
use Claromentis\Core\Application;
use Claromentis\Core\Http\JsonPrettyResponse;
use Claromentis\Core\Http\StatusCode;
use Psr\Http\Message\ServerRequestInterface as Request;
use Claromentis\Core\Http\TemplaterCallResponse;
use RestFormat;






class RestV2Controller
{
    
    
    
    
    protected $formatter;
    
    
    
    
    public function __construct(RestFormat $formatter)
    {
        $this->formatter = $formatter;
    }
    
    
    
    
    
    
    
    
    public function AddLike(Application $app, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        $app->likes->Add($aggregation, $object_id, $app->security->GetUserId());
        $_1f24efd4735b7a11b391147435e7d35d = [$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_f4eafa5f493306ffd" . "b51a688b21dd507"] => (int) $app->likes->GetCount($aggregation, $object_id)];
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d, StatusCode::OK);
    }
    public function RemoveLike(Application $app, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        $app->likes->Remove($aggregation, $object_id, $app->security->GetUserId());
        $_1f24efd4735b7a11b391147435e7d35d = [$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_f4eafa5f493306f" . "fdb51a688b21dd50" . "7"] => (int) $app->likes->GetCount($aggregation, $object_id)];
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d, StatusCode::OK);
    }
    
    
    
    
    
    
    
    
    public function GetMeLiked(Application $app, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        $_1f24efd4735b7a11b391147435e7d35d = [$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_532af466941018fd3954ccc8aed6" . "a235"] => (bool) $app->likes->IsLiked($aggregation, $object_id, $app->security->GetUserId())];
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d);
    }
    
    
    
    
    
    
    public function GetLikesCount(Application $app, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        $_1f24efd4735b7a11b391147435e7d35d = [$GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_f4eafa5f493306ffdb51a688b21dd5" . "07"] => (int) $app->likes->GetCount($aggregation, $object_id)];
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d);
    }
    
    
    
    
    
    
    
    public function GetLikes(Application $app, Request $request, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        list($_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2) = $this->formatter->PagingGetLimits($request->getQueryParams());
        $_f4eafa5f493306ffdb51a688b21dd507 = $app->likes->GetCount($aggregation, $object_id);
        if ($_f4eafa5f493306ffdb51a688b21dd507 > 0) {
            $likes = $app->likes->GetLikes($aggregation, $object_id, $_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2);
        } else {
            $likes = [];
        }
        $_1f24efd4735b7a11b391147435e7d35d = $this->formatter->PagingContainer($likes, $_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2, $_f4eafa5f493306ffdb51a688b21dd507);
        return new JsonPrettyResponse($_1f24efd4735b7a11b391147435e7d35d);
    }
    
    
    
    
    
    
    
    public function GetLikesHtml(Application $app, Request $request, $object_type, $object_id)
    {
        list($aggregation, $object_id) = $this->CheckObject($object_type, $object_id, $app);
        list($_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2) = $this->formatter->PagingGetLimits($request->getQueryParams());
        $likes = $app->likes->GetLikes($aggregation, $object_id, $_f11369824f533e8206f9ccc0c9aab3a0, $_1f50e30be8c2fefa6881834e71d504a2);
        $_e7438083ff42e99584f6022253250369 = [];
        foreach ($likes as $_9ecb1a728fdb50fbae4581f824a09366) {
            $user_id = $_9ecb1a728fdb50fbae4581f824a09366[$GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["user" . "_id"]];
            $_343a395319323dd7609bcbc465b4d034 = [$GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_71f564ea75084c6f261" . "db81c655d2f73"] => \User::GetProfileUrl($user_id), $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_5e8488c301cda0085b5ca6c78c50687" . "d"] => \User::GetPhotoUrl($user_id), $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_37317e99fd1ac0bd2c" . "ca360fcc5fd612"] => \User::GetNameById($user_id)];
            if ($_343a395319323dd7609bcbc465b4d034[$GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_37317e99fd1ac0bd" . "2cca360fcc5fd612"]] != $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_4d707fab93" . "bebb00bbe69" . "e8159697c90"]) {
                
                
                $_e7438083ff42e99584f6022253250369[] = $_343a395319323dd7609bcbc465b4d034;
            }
        }
        $args = [$GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_2409bed91" . "8465b496e1" . "f712f2c651" . "403"] => $_e7438083ff42e99584f6022253250369];
        $template = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_5203b6250b088a619" . "af741a56f3a0c26"];
        return new TemplaterCallResponse($template, $args);
    }
    
    
    
    
    
    
    private function CheckObject($object_type, $object_id, Application $app)
    {
        if (!$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_62d701c3" . "c53404f06" . "345eb3572" . "0a47b4"]($object_type)) {
            $aggregation = \ClaAggregations::GetNumByCode($object_type);
        } elseif ($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_62d701c3c53404" . "f06345eb35720a4" . "7b4"]($object_type)) {
            $aggregation = (int) $object_type;
        }
        if (empty($aggregation)) {
            throw new \RestExBadRequest($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_aa45d9aa411eac890badddf" . "edf2ade38"]);
        }
        if (!$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_62d701c3c53404f06345eb35720a47b" . "4"]($object_id)) {
            throw new \RestExBadRequest($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_5784e706ef84e048186a70a164f" . "cc358"]);
        }
        
        
        return array($aggregation, $object_id);
    }
}